'use strict';

var PerfilController = angular.module('PerfilController', []);

PerfilController.controller('PerfilCtrl', ['$scope', '$routeParams', 'Cliente', 'UploadApp', 'CacheApp',
    ($scope, $routeParams, Cliente, UploadApp, CacheApp) => {
        $scope.setAlteraSenha = (senha) => {
            $scope.deuErro = false;
            Cliente.setAlteraSenha(senha,
                (data) => {
                    if (data.Code != 0) {
                        $scope.deuErro = true;
                        $scope.mensagem = data.Description;
                    }
                    else
                        $scope.alteraSenha = false;
                }
            );
        }
        $scope.mudou = (fileAvatar) => {
            $scope.file = fileAvatar;
        }

        $scope.ClienteUpdate = (cliente) => {
            Cliente.ClienteUpdate(cliente,
                (data) => {
                    $scope.cliente.Celular = cliente.Celular;
                    $scope.sessao.Celular = cliente.Celular;
                    $scope.sessao.Nome = cliente.Nome;
                    $scope.sessao.Email = cliente.Email;
                    CacheApp.setSessao($scope.sessao);

                    $scope.salvarAvatar();
            });
        }

        $scope.salvarAvatar = () => {
            if ($scope.file) {
                $scope.progress = 0;
                UploadApp.UploadImagemAvatar($scope.file,
                    (progress) => {
                        $scope.progress = progress;
                    },
                    (result) => {
                        $scope.getListaObraCache({refresh: true},
                            (obra)=> {
                                $scope.progress = null;
                                $scope.alterar = false;
                                $scope.cliente.Avatar = result.Instance.Avatar;
                                $scope.sessao.Avatar = result.Instance.Avatar;
                                CacheApp.setSessao($scope.sessao);
                            }
                        )
                    },
                    (error) => {})
            }
            else
                $scope.getListaObraCache({refresh: true},
                    (obra)=> {
                        $scope.alterar = false;
                        CacheApp.setSessao($scope.sessao);
                    }
                )
        }

        $scope.getListaIdioma = () => {
            Cliente.getListaIdioma((data) => {
                $scope.listaIdioma = data.Instance;
            })
        }

        $scope.setIdiomaCliente = () => {
            var params = {
                IdIdioma: $scope.IdiomaSelecionado.Id
            }
            Cliente.setIdiomaCliente(params, (data) => {
                CacheApp.delIdioma();
                CacheApp.setIdioma({
                    IdIdioma: $scope.IdiomaSelecionado.Id,
                    Idioma: $scope.IdiomaSelecionado.Descricao,
                    TagPage: $scope.IdiomaSelecionado.TagPage,
                })

                $scope.sessao.IdIdioma = $scope.IdiomaSelecionado.Id;
                $scope.sessao.Idioma = $scope.IdiomaSelecionado.Descricao;
                $scope.sessao.TagPage = $scope.IdiomaSelecionado.TagPage;
                CacheApp.setSessao($scope.sessao);

    
                $scope.idioma = CacheApp.getIdioma();
            })
        }

        $scope.getPlanoContratado = () => {
            $scope.contrato = {};
            var params = {IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined}
            Cliente.getPlanoContratado(params,
                (data) => {
                    $scope.contrato = data.Instance;
                }
            );
        }

        $scope.getPlanoPagamentos = () => {
            $scope.listaPagamento = [];
            var params = {IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined}
            Cliente.getPlanoPagamentos(params,
                (data) => {
                    $scope.listaPagamento = data.Instance;
                }
            );
        }

        $scope.downloadBoleto = (url) => {
            window.open(url,'_blank');
        }

        $scope.AcessoAndroid($routeParams, (sim) => {
            $scope.sessao = CacheApp.getSessao();
            $scope.idioma = CacheApp.getIdioma();
            $scope.IdiomaSelecionado = {Id: $scope.idioma ? $scope.idioma.IdIdioma : 1}
            $scope.getListaIdioma();

            $scope.alterar = false;
            $scope.deuErro = false;

            $scope.cliente = {
                Email: $scope.sessao.Email,
                Nome: $scope.sessao.Nome,
                Celular: $scope.sessao.Celular,
                Avatar: $scope.sessao.Avatar
            };

            $scope.getPlanoContratado();
            $scope.getPlanoPagamentos();
        });

    }]);

